/*
 *	%Z% %M% %I% %D% %Q%
 *
 *	Copyright (C) Microsoft Corporation, 1983
 *
 *	This Module contains Proprietary Information of Microsoft
 *	Corporation and AT&T, and should be treated as Confidential.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS SPECIFIC TO THE
 * INTEL 80286 CPU AND MAY REQUIRE MODIFICATION
 * WHEN ADAPTING XENIX TO NEW HARDWARE.
 */


/*
 * Index of the users' stored
 * registers relative to AX.
 * Usage is u.u_ar0[XX].
 * EVERYTHING HERE IS DEPENDENT ON trap: in mch.s and trap.c
 * AND THE HARDWARE
 */

/*
 * users regs on kernel stack
 */
#define	RSS	7		/* user ss */
#define	RSP	6		/* user sp */
#define USP	6
#define	RFL	5
#define	RCS	4
#define	RIP	3
#define	Rviol	2
#define	RES	1
#define	RAX	0
#define	RCX	-1
#define	RDX	-2
#define	RBX	-3
#define	RKSP	-4		/* NOT sp to user's stack */
#define	RBP	-5
#define	RSI	-6
#define	RDI	-7
#define	RDS	-8


#define CBIT	0x0001		/* 'Carry' bit in flags     */
#define PBIT	0x0004		/* 'Parity' bit in flags     */
#define ABIT	0x0010		/* 'Auxiliary Carry' bit in flags     */
#define ZBIT	0x0040		/* 'Zero' bit in flags     */
#define SBIT	0x0080		/* 'Sign' bit in flags     */
#define TBIT	0x0100		/* 'Trace' bit in 'flags' */
#define IBIT	0x0200		/* 'Interrupt' enable bit */
#define DBIT	0x0400		/* 'Direction' flag */
#define OBIT	0x0800		/* 'Overflow' bit in flags */
#define NTBIT   0x4000		/* 'Nested Task Flag' bit  */

